//-----------------------------------------------------------------------------
//Api_2_Ueh_Gcst_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.toolkit.api_2_ueh_gcst;

//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------
import uicc.toolkit.*;
import uicc.usim.toolkit.* ;
import uicc.usim.test.util.* ;

/**
* Test Area : uicc.usim.tookit.USATEnvelopeHandler.getChannelStatus((byte)0x01);
* 
* Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV, EVENT_UNRECOGNIZED_ENVELOPE,
* EVENT_EVENT_DOWNLOAD_CHANNEL_STATUS
*/
public class Api_2_Ueh_Gcst_1  extends TestToolkitApplet
{
    // Number of tests
    byte testCaseNb = (byte) 0x00;
    private final byte[] ADDRESS = {(byte)0x91, (byte)0x11, (byte)0x22, (byte)0x33, (byte)0x44} ;
    private final byte[] BEARER_DESC = {(byte)0x01, (byte)0x00, (byte)0x00, (byte)0x00};
    private static byte[] displayString = {(byte)'H', (byte)'E', (byte)'L', (byte)'L', (byte)'O'};
      
    /**
    * Constructor of the applet
    */
    public Api_2_Ueh_Gcst_1 () 
    {
    }
    
    
    /**
    * Method called by the JCRE at the installation of the applet
    */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        Api_2_Ueh_Gcst_1  thisApplet = new Api_2_Ueh_Gcst_1 ();
        
        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        
        // Initialise the data of the test applet
        thisApplet.init();  
        
        // Set Event Download Channel Status as an activation event for the applet
        thisApplet.obReg.setEvent(EVENT_EVENT_DOWNLOAD_CHANNEL_STATUS);
        // Set Unrecognized Envelope as an activation event for the applet
        thisApplet.obReg.setEvent(EVENT_UNRECOGNIZED_ENVELOPE);
          // Set Formatted Envelope as an activation event for the applet
        thisApplet.obReg.setEvent(EVENT_FORMATTED_SMS_PP_ENV);
    
    }
    
    
    /**
     * Method called by the SIM Toolkit Framework
    */
    public void processToolkit(short event) 
    {
        // Result of tests
        boolean bRes ;
        
        // Get the system instance of handlers
        USATEnvelopeHandler envHdlr = USATEnvelopeHandlerSystem.getTheHandler();
        ProactiveHandler proHdlr = ProactiveHandlerSystem.getTheHandler() ;
        
        if (event == EVENT_FORMATTED_SMS_PP_ENV)
        {
            // The Applet open  the channel by sending Open Channel command
            proHdlr.init(PRO_CMD_OPEN_CHANNEL, (byte)0x01, (byte)0x82);
            proHdlr.appendTLV(TAG_ADDRESS, ADDRESS, (short)0x00, (short)ADDRESS.length);
            // CSD Bearer Description
            proHdlr.appendTLV(TAG_BEARER_DESCRIPTION, BEARER_DESC, (short)0x00, (short)BEARER_DESC.length);
            // Buffer size
            proHdlr.appendTLV(TAG_BUFFER_SIZE, (byte)0x00, (byte)0x80);
            proHdlr.send() ;
         }
        else
        {
            switch ( testCaseNb ) 
            {
                //=================================================================
                //=========        FORMATTED SMS PP ENV triggering        =========
                //=================================================================
                case (byte) 0 :
                    // --------------------------------------------
                    // Test Case 1 : Channel status TLV is not present 
                    testCaseNb = (byte) 1 ;
                
                    bRes = false ;
                    try {
                        short returnvalue = envHdlr.getChannelStatus((byte)0x01);
                
                    }
                    catch (ToolkitException e)    {
                        if(e.getReason()== ToolkitException.UNAVAILABLE_ELEMENT) 
                           bRes = true ;
                
                        else
                           bRes = false ;
                
                    }
                    catch (Exception e)    {   
                        
                            bRes = false ;
                    }
                    reportTestOutcome(testCaseNb, bRes) ;
                    break;
                    
                
                case (byte) 1 :
                    // --------------------------------------------
                    // Test Case 2 : Channel status TLV with the identifier is not present
                    bRes = false ;
                    testCaseNb = (byte) 2;
            
                    try {
                        short returnvalue = envHdlr.getChannelStatus((byte)0x02);
                    }
                    catch (ToolkitException e)    {
                        if(e.getReason()== ToolkitException.UNAVAILABLE_ELEMENT) 
                            bRes = true ;
                        else
                            bRes = false ;
                    }
                    catch (Exception e)    {    
                            bRes = false ;
                    }
                    reportTestOutcome(testCaseNb, bRes) ;
                    break;
            
                                
                case (byte) 2 :
                    // --------------------------------------------
                    // Test Case 3 : Channel status TLV with a length equal to 0
                    testCaseNb = (byte) 3;
            
                    bRes = false ;
                    try {
                        short returnvalue = envHdlr.getChannelStatus((byte)0x01);
                    }
                    catch (ToolkitException e)    {
                        if(e.getReason()== ToolkitException.UNAVAILABLE_ELEMENT) 
                            bRes = true ;
                        else
                            bRes = false ;
                    }
                    catch (Exception e)    {    
                            bRes = false ;
                    }
                    reportTestOutcome(testCaseNb, bRes) ;
                    break;
                                    
                case (byte) 3 :
                    // --------------------------------------------
                    // Test Case 4 : Channel status TLV with a length equal to 1
                    testCaseNb = (byte) 4 ;
            
                    bRes = false ;
                    try {
                        short returnvalue = envHdlr.getChannelStatus((byte)0x01);
                    }
                    catch (ToolkitException e)    {
                        if(e.getReason()== ToolkitException.OUT_OF_TLV_BOUNDARIES) 
                            bRes = true ;
                        else
                            bRes = false ;
                    }
                    catch (Exception e)    {    
                            bRes = false ;
                    }
                    reportTestOutcome(testCaseNb, bRes) ;
                    break;
                    
                case (byte) 4 :
                    // --------------------------------------------
                    // Test Case 5 : Get channel status value
                    testCaseNb = (byte) 5 ;
            
                    bRes = false ;
                    try {
                        if (envHdlr.getChannelStatus((byte)0x01)==(short)0x8100)
                            bRes = true;
                    }
                    catch (Exception e)    {    
                        bRes = false ;
                    }
                    reportTestOutcome(testCaseNb, bRes) ;
                    break;
                    
                case (byte) 5 :
                    // --------------------------------------------
                    // Test Case 6 : Get channel status value with 2 TLV  
                    testCaseNb = (byte) 6 ;
            
                    bRes = false ;
                    try {
                        if (envHdlr.getChannelStatus((byte)0x01) == (short)0x8100)
                            bRes = true;
                    }
                    catch (Exception e)    {    
                        bRes = false ;
                    }
                    reportTestOutcome(testCaseNb, bRes) ;
                    break;
                    
                case (byte) 6 :
                    // --------------------------------------------
                    // Test Case 7 : Get channel status value with 2 TLV  
                    testCaseNb = (byte) 7 ;
            
                    bRes = false ;
                    try {
                        if (envHdlr.getChannelStatus((byte)0x02) == (short)0x8201)
                            bRes = true;
                    }
                    catch (Exception e)    {    
                        bRes = false ;
                    }
                    reportTestOutcome(testCaseNb, bRes) ;
                    break;
                    
                case (byte) 7 :
                    // --------------------------------------------
                    // Test Case 8 : Channel status TLV is currently selected TLV
                    testCaseNb = (byte) 8 ;
            
                    bRes = false ;
                   try {
                        if((envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)1)!=TLV_NOT_FOUND)&&
                            (envHdlr.getChannelStatus((byte)0x01) == (short)0x8100)&&
                            (envHdlr.getValueShort((short)0)==(short)0x8100))
                            bRes = true;
                    }
                    catch (Exception e)    {    
                        bRes = false ;
                    }
                    reportTestOutcome(testCaseNb, bRes) ;
                    break;
                    
                case (byte)8 :
                    // --------------------------------------------
                    // Test Case 9 : Get channel status value after a proactive command
                    testCaseNb = (byte) 9 ;
            
                    bRes = false ;
                    try {
                    if (envHdlr.getChannelStatus((byte)0x01) == (short)0x8100)
                        bRes = true;
                        proHdlr.initDisplayText((byte)0x80, (byte)0x04, displayString, (short) 0, (short) displayString.length);
                        proHdlr.send();
                        if (envHdlr.getChannelStatus((byte)0x01) == (short)0x8100)
                            bRes &= true;
                    }
                    catch (Exception e)    {    
                        bRes &= false ;
                    }
                    reportTestOutcome(testCaseNb, bRes) ;
            
                    break;

            }
        }
    }
}
