//-----------------------------------------------------------------------------
//Api_2_Ueh_Giid_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.toolkit.api_2_ueh_giid;

//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------
import uicc.toolkit.* ;
import uicc.usim.toolkit.* ;
import uicc.usim.test.util.* ;

/**
* Test Area : uicc.usim.tookit.USATEnvelopeHandler.getItemIdentifier()
* 
* Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
*
*/
public class Api_2_Ueh_Giid_1  extends TestToolkitApplet
{
    // Number of tests
    byte testCaseNb = (byte) 0x00;
    private static byte[] displayString = {(byte)'H', (byte)'E', (byte)'L', (byte)'L', (byte)'O'};
      
    /**
    * Constructor of the applet
    */
    public Api_2_Ueh_Giid_1 () 
    {
    }
    
    
    /**
    * Method called by the JCRE at the installation of the applet
    */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        Api_2_Ueh_Giid_1  thisApplet = new Api_2_Ueh_Giid_1 ();
        
        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        
        // Initialise the data of the test applet
        thisApplet.init();    
        
        // Set Formatted SMS PP UPD as an activation event for the applet
        thisApplet.obReg.setEvent(EVENT_FORMATTED_SMS_PP_ENV);
        
    }
    
    
    /**
     * Method called by the SIM Toolkit Framework
    */
    public void processToolkit(short event) 
    {
        // Result of tests
        boolean bRes ;
        
        // Get the system instance of handlers
        USATEnvelopeHandler envHdlr = USATEnvelopeHandlerSystem.getTheHandler();
        ProactiveHandler proHdlr = ProactiveHandlerSystem.getTheHandler() ;
        
        switch ( testCaseNb ) 
        {
            //=================================================================
            //=========        FORMATTED SMS PP ENV triggering        =========
            //=================================================================
            case (byte) 0 :
                // --------------------------------------------
                // Test Case 1 : Send envelope formatted SMS with an item identifier 
                // TLV and identifier value of 03
    
                bRes = false ;
                testCaseNb = (byte) 1 ;
                try {
                    if (envHdlr.getItemIdentifier() == (byte)0x03)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 1 :
                // --------------------------------------------
                // Test Case 2 : Send envelope formatted SMS with two item identifier TLV with
                // first value FF and second 44
                bRes = false ;
                testCaseNb = (byte) 2 ;
                try {
                    if (envHdlr.getItemIdentifier() == (byte)0xFF)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
        
            case (byte) 2 :
                // --------------------------------------------
                // Test Case 3 : Send envelope formatted SMS with two item identifier TLV with
                // first value 81 and second 44, call twice the method getItemIdentifier() 
                testCaseNb = (byte) 3;
    
                bRes = false ;
                try {
                    if ((envHdlr.getItemIdentifier() == (byte)0x81) && (envHdlr.getItemIdentifier() == (byte)0x81))
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
                
            case (byte) 3 :
                // --------------------------------------------
                // Test Case 4 : Send envelope envelope formatted SMS with item identifier TLV and value of 66. 
                // FindTLV() with TAG 02. getItemIdentifier() and then getValueByte() with offset 0
                testCaseNb = (byte) 4 ;
    
                bRes = false ;
                try {
                    envHdlr.findTLV(TAG_DEVICE_IDENTITIES, (byte)1);
                    if ( envHdlr.getItemIdentifier() ==  envHdlr.getValueByte((short)0) )
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 4 :
                // --------------------------------------------
                // Test Case 5 : Send envelope formatted SMS without item identifier TLV and getItemIdentifier()
                testCaseNb = (byte) 5 ;
    
                bRes = false ;
                try {
                    envHdlr.getItemIdentifier();
                    bRes = false;
                }
                catch (ToolkitException e)    {    
                    if (e.getReason() == ToolkitException.UNAVAILABLE_ELEMENT )
                        bRes = true;
                    
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 5 :
                // --------------------------------------------
                // Test Case 6 : Send envelope formatted SMS with item identifier TLV (66), send proactive command.
                // Then getItemIdentifier() 
                testCaseNb = (byte) 6 ;
    
                bRes = false ;
                try {
                    proHdlr.initDisplayText((byte)0x80, (byte)0x04, displayString, (short) 0, (short) displayString.length);
                    proHdlr.send();
                    if (envHdlr.getItemIdentifier() == (byte) 0x66)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
    
                break;
    
            case (byte) 6 :
                // --------------------------------------------
                // Test Case 7 : Receive envelope with item identifier TLV but without item number, send proactive command.
                testCaseNb = (byte) 7 ;
    
                bRes = false ;
                try {
                    if (envHdlr.getItemIdentifier() == (byte) 0x00)
                        bRes = false;
                }
                catch (ToolkitException e)    {    
                    if (e.getReason() == ToolkitException.OUT_OF_TLV_BOUNDARIES)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
    
            break;
    
        }
    }
}