//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.toolkit.api_2_ueh_gsdo;

//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------
import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;
import org.etsi.scp.wg3.uicc.jcapi.userclass.*;
import org._3gpp.ct.wg6.usim.jcapi.userclass.*;

public class Test_Api_2_Ueh_Gsdo extends UiccTestModel {
    
    static final String CAP_FILE_PATH = "uicc/usim/test/toolkit/api_2_ueh_gsdo";
    static final String CLASS_AID_1 = "A0000000 871005FF FFFFFF89 20010001";
    static final String APPLET_AID_1 = "A0000000 871005FF FFFFFF89 20010102";
    
    
    private USimAPITestCardService test;
    APDUResponse response;
    
        
    public Test_Api_2_Ueh_Gsdo() {
        test = USimAPITestCardService.getTheUSimTestCardService();
    }

    public boolean run() {
        initialiseResults();
        
        // test script
        test.reset();
        test.terminalProfileSession("1719");
        
        
        // Install package
        test.loadPackage(CAP_FILE_PATH);
            
        // Install Applet
        response = test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1, 
            "8008" + // TLV UICC Toolkit application specific parameters
                "01" +   // V Priority Level
                "00" +   // V Max. number of timers
                "00" +   // V Maximum text length for a menu entry
                "00" +   // V Maximum number of menu entries                              
                "00" +   // V Maximum number of channels 
                "00" +   // LV Minimum Security Level field
                "00" +   // LV TAR Value(s) 
                "00" );  // V Maximum number of services
        
        addResult(response.checkSw("9000"));
        
        test.reset();
        test.terminalProfileSession("1719");
        
        /*********************************************************************/
        /** FORMATTED SMS PP ENV Triggering                                  */
        /*********************************************************************/
        
        // Testcase 1. Test with TP-OA length of 2 and RC/CC/DS length is 0 */
        test.envelopeSmsPp( "8B4B4002 81557FF6 00112912 0000043D" +
                            "02700000 380D0800 00002001 01000000" +
                            "00010011 22334455 66778899 10111213" +
                            "14151617 18191A1B 1C1D1E1F 20212223" +
                            "24252627 28292A2B 2C2D2E2F 30");
        
        
        // Testcase 2. Test with TP-OA length of 6 and RC/CC/DS length is 0 
        test.envelopeSmsPp( "8B4D4006 81556677 7FF60011 29120000" +
                            "043D0270 0000380D 08000000 20010100" +
                            "00000001 00112233 44556677 88991011" +
                            "12131415 16171819 1A1B1C1D 1E1F2021" +
                            "22232425 26272829 2A2B2C2D 2E2F30");
        
         
        // Testcase 3. Test with TP-OA length of 12 and RC/CC/DS length is 0 
        test.envelopeSmsPp( "8B50400C 81334455 6677887F F6001129" +
                            "12000004 3D027000 00380D08 00000020" +
                            "01010000 00000100 11223344 55667788" +
                            "99101112 13141516 1718191A 1B1C1D1E" +
                            "1F202122 23242526 2728292A 2B2C2D2E" +
                            "2F30");
        
        
        // Testcase 4. Test with RC/CC/DS length of 8 and TP-OA length is 2 
        test.envelopeSmsPp( "8B394002 81557FF6 00112912 0000042B" +
                            "02700000 26150A02 00112001 01000000" +
                            "00010031 2BFC8086 E1033501 02030405" +
                            "06070809 0A0B0C0D 0E0F10");
        
        
        // Testcase 5. Send a SMS PP with 2 TPDU TLV and inside two         
        // different secured data offsets 0                                 
        test.envelopeSmsPp( "8B294008 81556677 887FF600 11291200" +
                            "00041802 70000013 0D080000 00200101" +
                            "00000000 01000102 0304058B 2C400281" +
                            "557FF600 11291200 00041D02 70000019" +
                            "0D080000 00200101 00000000 00010001" +
                            "02030405 06070809 0A");
        
        
        // Testcase 6. Same test as     CASE 1 but without any secured data    
        test.envelopeSmsPp( "8B214002 81557FF6 00112912 00000413" +
                            "02700000 0E0D0800 00002001 01000000" +
                            "000100");
        
        
        // Testcase 7. Test with FORMATTED_SMS_PP ENV Verify after call     
        // of the method the current TLV is the TPDU TLV: findTLV device     
        // identities, getSecuredDataOffset and then getValueByte to verify 
        // that the current TLV is the TPDU TLV                             
        test.envelopeSmsPp( "8B294008 81556677 887FF600 11291200" +
                            "00041802 70000013 0D080000 00200101" +
                            "00000000 02001011 121314");
        
        
        // Testcase 8-1.  Concatenated SMS with maximum user data            
        // length = 0x10D Secured data length = 0xFA                                              
        // 1st envelope                                                     
        test.envelopeSmsPp( "8B819A40 0281557F F6001129 12000004" +
                            "8C070003 00020170 0001080D 08000000" +
                            "20010100 00000001 00010203 04050607" +
                            "08090A0B 0C0D0E0F 10111213 14151617" +
                            "18191A1B 1C1D1E1F 20212223 24252627" +
                            "28292A2B 2C2D2E2F 30313233 34353637" +
                            "38393A3B 3C3D3E3F 40414243 44454647" +
                            "48494A4B 4C4D4E4F 50515253 54555657" +
                            "58595A5B 5C5D5E5F 60616263 64656667" +
                            "68696A6B 6C6D6E6F 70717273 74");
         
        
        // Testcase 8-2.  Concatenated SMS with maximum user data          
        // length = 0x10D Secured data length = 0xFA                                           
        // 2ND envelope                                                    
        test.envelopeSmsPp( "8B819A40 0281557F F6001129 12000004" +
                            "8C050003 00020275 76777879 7A7B7C7D" +
                            "7E7F8081 82838485 86878889 8A8B8C8D" +
                            "8E8F9091 92939495 96979899 9A9B9C9D" +
                            "9E9FA0A1 A2A3A4A5 A6A7A8A9 AAABACAD" +
                            "AEAFB0B1 B2B3B4B5 B6B7B8B9 BABBBCBD" +
                            "BEBFC0C1 C2C3C4C5 C6C7C8C9 CACBCCCD" +
                            "CECFD0D1 D2D3D4D5 D6D7D8D9 DADBDCDD" +
                            "DEDFE0E1 E2E3E4E5 E6E7E8E9 EAEBECED" +
                            "EEEFF0F1 F2F3F4F5 F6F7F8F9 FA");
        
        /*********************************************************************/
        /** FORMATTED SMS PP UPD Triggering                                  */
        /*********************************************************************/
        
        // Testcase 9.  Same test as 1 but with FORMATTED_SMS_PP_UPD                       
        //select EF SMS
        test.selectFile("3F00");
        test.selectFile("7F10");
        test.selectFile("6F3C");
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 0281557F F6001129" +
                            "12000004 3D027000 00380D08 00000020" +
                            "01010000 00000100 11223344 55667788" +
                            "99101112 13141516 1718191A 1B1C1D1E" +
                            "1F202422 23242526 2728292A 2B2C2D2E" +
                            "2F30FFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
        
        // Testcase 10.  Same test as 2 but with FORMATTED_SMS_PP_UPD                     
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 06815566 777FF600" +
                            "11291200 00043D02 70000038 0D080000" +
                            "00200101 00000000 01001122 33445566" +
                            "77889910 11121314 15161718 191A1B1C" +
                            "1D1E1F20 24222324 25262728 292A2B2C" +
                            "2D2E2F30 FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" );
        
        // Testcase 11.  Same test as 3 but with FORMATTED_SMS_PP_UPD                      
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 0C813344 55667788" +
                            "7FF60011 29120000 043D0270 0000380D" +
                            "08000000 20010100 00000001 00112233" +
                            "44556677 88991011 12131415 16171819" +
                            "1A1B1C1D 1E1F2021 22232425 26272829" +
                            "2A2B2C2D 2E2F30FF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
        
         // Testcase 12.  Same test as 4 but with FORMATTED_SMS_PP_UPD                      
        
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 0281557F F6001129" +
                            "12000004 2B027000 0026150A 02001120" +
                            "01010000 00000100 70C8F096 D32674EE" +
                            "10111213 14151617 18191A1B 1C1D1E1F" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF ");
        
        // Testcase 13.  Same test as 5 but with FORMATTED_SMS_PP_UPD                      
        
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 08815566 77887FF6" +
                            "00112912 00000418 02700000 130D0800" +
                            "00002001 01000000 00010001 02030405" +
                            "40028155 7FF60011 29120000 041D0270" +
                            "0000180D 08000000 20010100 00000001" +
                            "00010203 04050607 08090AFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF ");
        
        // Testcase 14.  Same test as 6 but with FORMATTED_SMS_PP_UPD                       
        
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 0281557F F6001129" +
                            "12000004 13027000 000E0D08 00000020" +
                            "01010000 00000100 FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
        
        // Testcase 15.  Test with FORMATTED_SMS_PP UPD Verify after call  
        // of the method the current TLV is the TPDU TLV: findTLV device    
        // identities, getSecuredDataOffset and then getValueByte to verify 
        // that the current TLV is the TPDU TLV                              
        
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 0281557F F6001129" +
                            "12000004 13027000 000E0D08 00000020" +
                            "01010000 00000100 FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +
                            "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
        
        // Testcase 16-1.  Same test as 8, but with a concatenated SMS            
        // (2 Short Messages and maximum Secured Data Length = 0x00FA)                     
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 0281557F F6001129" +
                            "12000004 8C070003 00020170 0001080D" +
                            "08000000 20010100 00000001 00010203" +
                            "04050607 08090A0B 0C0D0E0F 10111213" +
                            "14151617 18191A1B 1C1D1E1F 20212223" +
                            "24252627 28292A2B 2C2D2E2F 30313233" +
                            "34353637 38393A3B 3C3D3E3F 40414243" +
                            "44454647 48494A4B 4C4D4E4F 50515253" +
                            "54555657 58595A5B 5C5D5E5F 60616263" +
                            "64656667 68696A6B 6C6D6E6F 70717273" +
                            "74FFFFFF FFFFFFFF FFFFFFFF FFFFFFFF");
        
        // Testcase 16-2.  Same test as 8, but with a concatenated SMS            
        // (2 Short Messages and maximum Secured Data Length = 0x00FA)                     
        test.updateRecord(  "01", "04", 
                            "03058011 22334440 0281557F F6001129" +
                            "12000004 8C050003 00020275 76777879" +
                            "7A7B7C7D 7E7F8081 82838485 86878889" +
                            "8A8B8C8D 8E8F9091 92939495 96979899" +
                            "9A9B9C9D 9E9FA0A1 A2A3A4A5 A6A7A8A9" +
                            "AAABACAD AEAFB0B1 B2B3B4B5 B6B7B8B9" +
                            "BABBBCBD BEBFC0C1 C2C3C4C5 C6C7C8C9" +
                            "CACBCCCD CECFD0D1 D2D3D4D5 D6D7D8D9" +
                            "DADBDCDD DEDFE0E1 E2E3E4E5 E6E7E8E9" +
                            "EAEBECED EEEFF0F1 F2F3F4F5 F6F7F8F9" +
                            "FAFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF ");
        
        /*********************************************************************/
        /** FORMATTED SMS CB Triggering                                      */
        /*********************************************************************/
        
        // Testcase 17. Same test as 2 but with FORMATTED_SMS_CB             
        test.envelopeCellBroadcast( "0C580000 1080F611 001E0D08 00000020" +
                                    "01010000 00000100 11223344 55667788" +
                                    "11223344 55667788 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 0000");
        
        // Testcase 18. Same test as 4 but with FORMATTED_SMS_CB            
        test.envelopeCellBroadcast( "0C580000 1080F611 0026150A 00001120" +
                                    "01010000 00000100 B737577A C22A601A" +
                                    "11223344 55667788 11223344 55667788" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 0000");
        
        
        // Testcase 19. Same test as 6 but with FORMATTED_SMS_CB            
        test.envelopeCellBroadcast( "0C580000 1080F611 000E0D08 00000020" +
                                    "01010000 00000100 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 0000");
        
        // Testcase 20 : Verify after call of the method the current TLV is the Cell Broadcast Page TLV                                   
        test.envelopeCellBroadcast( "0C580000 1080F611 000E0D08 00000020" +
                                    "01010000 00000100 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 0000");
        
        /*********************************************************************/
        /** Unformatted Envelope Triggering                                    */
        /*********************************************************************/
        
        // Testcase 21 Send an UNFORMATTED SMS CB envelope, getSecuredDataOffset                                             
        test.envelopeCellBroadcast( "0C580000 10000000 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 00000000 00000000" +
                                    "00000000 00000000 0000");
         
        // Testcase 22. Send an UNFORMATTED SMS PP envelope, getSecuredDataOffset                                                          
        test.envelopeSmsPp( "8B16100881 55667788 7FF60011 29120000" +
                            "04051011 121314");
         
        /***********************************/        
        /**         Check results          */        
        /***********************************/         
        
        // Select applet
        response = test.selectApplication(APPLET_AID_1);
        addResult(response.checkData("10" + APPLET_AID_1 +
                                    "16CCCCCC CCCCCCCC CCCCCCCC CCCCCCCC" +
                                    "CCCCCCCC CCCCCC"));
        
        
        test.reset();
        test.terminalProfileSession("1719");
                                           
        // Delete Applet 
        test.deleteApplet(APPLET_AID_1);
        // Delete Package
        test.deletePackage(CAP_FILE_PATH);   
      
        return getOverallResult();
    }
}   
