//-----------------------------------------------------------------------------
//Api_2_Ueh_Gtpo_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.toolkit.api_2_ueh_gtpo;

//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------

import uicc.usim.toolkit.* ;
import uicc.usim.test.util.* ;

/**
* Test Area : uicc.usim.tookit.USATEnvelopeHandler.getTPUDLOffset()
* 
* Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV, EVENT_FORMATTED_SMS_PP_UPD,
* EVENT_FORMATTED_SMS_CB, EVENT_UNFORMATTED_SMS_CB, EVENT_UNFORMATTED_SMS_PP_ENV, EVENT_UNFORMATTED_SMS_PP_UPD
*
*/
public class Api_2_Ueh_Gtpo_1  extends TestToolkitApplet
{
    // Number of tests
    byte testCaseNb = (byte) 0x00;
      
    /**
    * Constructor of the applet
    */
    public Api_2_Ueh_Gtpo_1 () 
    {
    }
    
    
    /**
    * Method called by the JCRE at the installation of the applet
    */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        Api_2_Ueh_Gtpo_1  thisApplet = new Api_2_Ueh_Gtpo_1 ();
        
        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        
        // Initialise the data of the test applet
        thisApplet.init();  
        
        // Set Formatted SMS PP ENV as an activation event for the applet
        thisApplet.obReg.setEvent(EVENT_FORMATTED_SMS_PP_ENV);
        
        // Set Formatted SMS PP UPD as an activation event for the applet
        thisApplet.obReg.setEvent(EVENT_FORMATTED_SMS_PP_UPD);
          
          // Set Unformatted SMS CB as an activation event for the applet
        thisApplet.obReg.setEvent(EVENT_UNFORMATTED_SMS_CB);
          
          // Set Unformatted SMS PP as an activation event for the applet
        thisApplet.obReg.setEvent(EVENT_UNFORMATTED_SMS_PP_ENV);
        
        // Set Unformatted SMS UPD as an activation event for the applet
        thisApplet.obReg.setEvent(EVENT_UNFORMATTED_SMS_PP_UPD);
    
    }
    
    
    /**
     * Method called by the SIM Toolkit Framework
    */
    public void processToolkit(short event) 
    {
        // Result of tests
        boolean bRes ;
        
        // Get the system instance of handlers
        USATEnvelopeHandler envHdlr = USATEnvelopeHandlerSystem.getTheHandler();
        
        switch ( testCaseNb ) 
        {
            //=================================================================
            //=========        FORMATTED SMS PP ENV triggering        =========
            //=================================================================
            case (byte) 0 :
                // --------------------------------------------
                // Test Case 1 : Test with various length of TP-OA:2
            
                bRes = false ;
                testCaseNb = (byte) 1 ;
                
                try {
                    if (envHdlr.getTPUDLOffset() == (short)0x000D)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 1 :
                // --------------------------------------------
                // Test Case 2 : Test with TP-OA length of 6
                bRes = false ;
                testCaseNb = (byte) 2 ;
                
                try {
                    if (envHdlr.getTPUDLOffset() == (short)0x000F)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 2 :
                // --------------------------------------------
                // Test Case 3 : Test with TP-OA length of 12
                testCaseNb = (byte) 3 ;
                bRes = false ;
                
                try {
                    if (envHdlr.getTPUDLOffset() == (short) 0x0012)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
                
            case (byte) 3 :
                // --------------------------------------------
                // Test Case 4 : Send a SMS PP with 2 TPDU TLV and inside two different UDL offsets 
                testCaseNb = (byte) 4 ;
                bRes = false ;
                try {
                    if (envHdlr.getTPUDLOffset() == (short)0x0010)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 4 :
                // --------------------------------------------
                // Test Case 5 : Same test as 1, but with a concatenated SMS 
                // (2 Short Messages and maximum Secured Data Length = 0x00FA)
                testCaseNb = (byte) 5 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getTPUDLOffset() == (short) 0x000D)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
                
            case (byte) 5 :
                // --------------------------------------------
                // Test Case 6 : Verify after call of the method the current TLV
                // is the TPDU TLV:findTLV device identities, getTPUDLOffset and then getValueByte
                // to verify that the current TLV is the TPDU TLV
                testCaseNb = (byte) 6 ;
            
                bRes = false ;
                try {
                    if((envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)1)!=TLV_NOT_FOUND)&&
                        (envHdlr.getTPUDLOffset() ==(short) 0x0010)&&
                        (envHdlr.getValueByte((short)0)==0x40))
                                            bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            
            //=================================================================
            //=========        FORMATTED SMS PP UPD triggering        =========
            //=================================================================
            case (byte) 6 :
                // --------------------------------------------
                // Test Case 7 : Test with TP-OA length of 2
                testCaseNb = (byte) 7 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getTPUDLOffset() == (short) 0x000D)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 7 :
                 // --------------------------------------------
                // Test Case 8 : Test with TP-OA length of 6
                testCaseNb = (byte) 8 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getTPUDLOffset() ==  (short)0x000F)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 8 :
                // --------------------------------------------
                // Test Case 9 : Test with TP-OA length of 12
                testCaseNb = (byte) 9 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getTPUDLOffset() ==  (short)0x0012)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 9 :
                // --------------------------------------------
                // Test Case 10 : Send a SMS PP with 2 TPDU TLV and inside two different UDL offsets
                testCaseNb = (byte) 10 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getTPUDLOffset() ==  (short)0x0010)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 10 :
                // --------------------------------------------
                // Test Case 11 : Test with secured data length = maximum length for 2 concatenated envelopes : 0xFA
                testCaseNb = (byte) 11 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getTPUDLOffset() ==  (short)0x000D)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            //=================================================================
            //=========          UNFORMATTED SMS PP ENV triggering    =========
            //=================================================================
            case (byte)11 :
                // --------------------------------------------
                // Test Case 12 : Test with TP-OA length of 2
                bRes = false ;
                testCaseNb = (byte) 12 ;
                try {
                    if (envHdlr.getTPUDLOffset() ==  (short)0x000D)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
                
            case (byte)12 :
                // --------------------------------------------
                // Test Case 13 : Test with TP-OA length of 6
                testCaseNb = (byte) 13 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getTPUDLOffset() == (short) 0x000F)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
                
            case (byte)13 :
                // --------------------------------------------
                // Test Case 14 : Test with TP-OA length of 12
                testCaseNb = (byte) 14 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getTPUDLOffset() == (short) 0x0012)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
                
            case (byte)14 :
                // --------------------------------------------
                // Test Case 15 : Send a SMS PP with 2 TPDU TLV and inside two different UDL offsets
                testCaseNb = (byte) 15 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getTPUDLOffset() == (short)0x0010)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
                
            case (byte)15 :
                // --------------------------------------------
                // Test Case 16 : Test with TP-OA length of 2 with a concatenated SMS
                //(2 Short Messages and maximum User Data Length = 0x010C)
                testCaseNb = (byte) 16 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getTPUDLOffset() == (short)0x000D)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
                
               
            //=================================================================
            //=========          UUNFORMATTED SMS PP UPD Triggering    ========
            //=================================================================
            case (byte) 16 :
                 // --------------------------------------------
                 // Test Case 17 : Test with TP-OA length of 2
                 testCaseNb = (byte) 17 ;
            
                bRes = false ;
                try {
                    if (envHdlr.getTPUDLOffset() == (short)0x000D)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
                
            case (byte) 17 :
                // --------------------------------------------
                // Test Case 18 : Test with TP-OA length of 6
                testCaseNb = (byte) 18 ;

                bRes = false ;
                try {
                    if (envHdlr.getTPUDLOffset() == (short) 0x000F)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
       
            case (byte) 18 :
                // --------------------------------------------
                // Test Case 19 : Test with TP-OA length of 12
                testCaseNb = (byte) 19;
            
                bRes = false ;
                try {
                    if (envHdlr.getTPUDLOffset() == (short) 0x0012)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 19 :
                // --------------------------------------------
                // Test Case 20 : Send a SMS PP with 2 TPDU TLV and inside two different UDL offsets
                testCaseNb = (byte) 20;
            
                bRes = false ;
                try {
                    if (envHdlr.getTPUDLOffset() == (short)0x0010)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            case (byte) 20 :
                // --------------------------------------------
                // Test Case 21 : Test with TP-OA length of 2 
                // but with a concatenated SMS (2 Short Messages and maximum User Data Length = 0x010C)
                testCaseNb = (byte) 21;
            
                bRes = false ;
                try {
                    if (envHdlr.getTPUDLOffset() == (short)0x000D)
                        bRes = true;
                }
                catch (Exception e)     {
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
            
            //=================================================================
            //=========                  ERROR TESTS                  =========
            //=================================================================
            case (byte) 21:
                // --------------------------------------------
                // Test Case 22 : Send an envelope Unformatted SMS CB, getTPUDLOffset
                testCaseNb = (byte) 22 ;
                
                bRes = false ;
                try {
                    short returned_value = envHdlr.getTPUDLOffset();
                        bRes = false;
                }
                catch (uicc.toolkit.ToolkitException e)    {    
                    if(e.getReason()==uicc.toolkit.ToolkitException.UNAVAILABLE_ELEMENT)
                        bRes = true ;
                }
                catch (Exception e)    {    
                        bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;

        }
   
    }

}
