//-----------------------------------------------------------------------------
//Ufw_Cbs_Mmra_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.usatframework.ufw_cbs_mmra;

//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------

import javacard.framework.*;
import uicc.toolkit.EnvelopeHandler;
import uicc.toolkit.EnvelopeHandlerSystem;
import uicc.usim.test.util.TestToolkitApplet;
import uicc.usim.toolkit.USATEnvelopeHandler;
import uicc.usim.toolkit.USATEnvelopeHandlerSystem;

public class Ufw_Cbs_Mmra_1 extends TestToolkitApplet
{
    /** number of the actual test case */
    private byte        bTestCaseNb       = (byte) 0x00;

    /** flag for test case 1. will be set to true if triggered */
    private boolean     tc1_triggered     = false;

    /** flag for test case 1. will be set to true if triggered */
    private boolean     tc2_triggered     = false;

    /** serial number of formatted sms-cb */

    /** contains SN,MsId,DCS,PP,CPL,CHL,SPI,KIC,KID,TAR,CNTR;PCNTR */
    private final byte[] HEADER_FORMATTED = new byte[]{
                                                       (byte)0xA7, (byte)0x50, (byte)0x10, (byte)0x93,
                                                       (byte)0xF6, (byte)0x33, (byte)0x00, (byte)0xF4,
                                                       (byte)0x0D, (byte)0x00, (byte)0x00, (byte)0x00,
                                                       (byte)0x00, (byte)0x50, (byte)0x01, (byte)0x01,
                                                       (byte)0x00, (byte)0x00, (byte)0x00, (byte)0x00,
                                                       (byte)0x00, (byte)0x00
                                                    };


    private final byte[] HEADER_UNFORMATTED = new byte[]{
                                                     (byte)0xA7, (byte)0x51,  (byte)0x10, (byte)0x77,
                                                     (byte)0xF6, (byte)0x13,  (byte)0x00, (byte)0x18,
                                                     (byte)0x0D, (byte)0x00,  (byte)0x00, (byte)0x00,
                                                     (byte)0x00, (byte)0x50,  (byte)0x01, (byte)0x01,
                                                     (byte)0x00, (byte)0x00,  (byte)0x00, (byte)0x00,
                                                     (byte)0x00, (byte)0x00,
                                                   };


    private static byte[] comparebuffer         = new byte[(short)300];


    /**
     * Create an instance of the Ufw_Cbs_Mmra_1 Applet
     *
     * @param bArray  the array containing installation parameters
     * @param bOffset the starting offset in bArray
     * @param bLength the length in bytes of the parameter data in bArray The maximum value of bLength is 127.
     * @throws ISOException if the install method failed
     * @see javacard.framework.Applet
     */
    public static void install(byte[] bArray, short bOffset, byte bLength) throws ISOException
    {
        Ufw_Cbs_Mmra_1 applet = new Ufw_Cbs_Mmra_1();
        // Register the new applet instance to the JCRE
        applet.register(bArray, (short) (bOffset + 1), bArray[bOffset]);
        applet.init();
        // register to events formatted and unformatted SMS-CB
        short eventlist[] = new short[]{
                                       EVENT_FORMATTED_SMS_CB,
                                       EVENT_UNFORMATTED_SMS_CB,
                                      };
        applet.obReg.setEventList(eventlist,(short)0,(short)eventlist.length);

        //initialise the compare buffer
        for (short index=(short)1;index<=(short)0xE6;index++){
            comparebuffer[(short)(index-1)]= (byte)index;
        }

    }

    /**
     * Method called by the UICC Toolkit Framework
     */
    public void processToolkit(short event)
    {
        boolean bRes     = false;
        byte compareRes  = (byte) 0x00;
        // get the envelope handler to check the content
        USATEnvelopeHandler usatEnvHdr = USATEnvelopeHandlerSystem.getTheHandler();
        //select TLV containing the SMS_CB
        usatEnvHdr.findTLV((byte) 0x8C, (byte) 0x01);
        switch (event) {
            // TC 1
            case EVENT_FORMATTED_SMS_CB:
                bTestCaseNb = (byte) 0x01;
                // check the complete content of sms cb structure
                compareRes =  usatEnvHdr.compareValue((short)0,HEADER_FORMATTED,(short)0,(short)22);
                compareRes |= usatEnvHdr.compareValue((short)22,comparebuffer,(short)0,(short)0xE6);
                if (compareRes == (byte) 0x00 && tc1_triggered == false) {
                    bRes = true;
                }
                tc1_triggered = true; // shall be triggered only once on receiving multiple pages sms_cb
                this.reportTestOutcome(bTestCaseNb, bRes);
                break;

            // TC 2
            case EVENT_UNFORMATTED_SMS_CB:
                bTestCaseNb = (byte) 0x02;
                // check the complete content of sms cb structure
                compareRes =  usatEnvHdr.compareValue((short)0,HEADER_UNFORMATTED,(short)0,(short)22);
                compareRes |= usatEnvHdr.compareValue((short)22,comparebuffer,(short)0,(short)0xE6);
                if (compareRes == (byte) 0x00 && tc2_triggered == false) {
                    bRes = true;
                }
                tc2_triggered = true; // shall be triggered only once on receiving multiple pages sms_cb
                this.reportTestOutcome(bTestCaseNb, bRes);
                break;

            default:
                // applet shall not be triggered on a part of a sms_cb or otherwise
                if (bTestCaseNb == (byte) 0x01) tc1_triggered = true;
                else if (bTestCaseNb == (byte) 0x02) tc2_triggered = true;
                reportTestOutcome(bTestCaseNb, false);
                break;
        }
    }


}
