//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.usatframework.ufw_exh_imtg;

//-----------------------------------------------------------------------------
//  Imports
//-----------------------------------------------------------------------------
import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;
import org.etsi.scp.wg3.uicc.jcapi.userclass.*;
import org._3gpp.ct.wg6.usim.jcapi.userclass.*;
import org._3gpp.ct.wg6.usim.jcapi.userinterface.*;


public class Test_Ufw_Exh_Imtg extends UiccTestModel {

    static final String CAP_FILE_PATH = "uicc/usim/test/usatframework/ufw_exh_imtg";
    static final String CLASS_AID_1 = "A0000000 871005FF FFFFFF89 50010001";
    static final String APPLET_AID_1 = "A0000000 871005FF FFFFFF89 50010102";
    
    static final String CLASS_AID_2 = "A0000000 871005FF FFFFFF89 50020001";
    static final String APPLET_AID_2 = "A0000000 871005FF FFFFFF89 50020102";
 
       
    private USimAPITestCardService test;
    APDUResponse response;
      
          
    public Test_Ufw_Exh_Imtg() {
        test = USimAPITestCardService.getTheUSimTestCardService();
    }
    
    public boolean run() {
        initialiseResults();
        
        // test script
        test.reset();
        test.terminalProfileSession("1701");
    

        // Install package
        test.loadPackage(CAP_FILE_PATH);
            
        // Install Applet1
        test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1, 
                           "8008" + // TLV UICC Toolkit application specific parameters
                               "01" +   // V Priority Level
                               "00" +   // V Max. number of timers
                               "00" +   // V Maximum text length for a menu entry
                               "00" +   // V Maximum number of menu entries                              
                               "00" +   // V Maximum number of channels 
                               "00" +   // LV Minimum Security Level field
                               "00" +   // LV TAR Value(s) 
                               "00" );  // V Maximum number of services
        
        // Install Applet2
        test.installApplet(CAP_FILE_PATH, CLASS_AID_2, APPLET_AID_2, 
                           "8008" + // TLV UICC Toolkit application specific parameters
                               "02" +   // V Priority Level
                               "00" +   // V Max. number of timers
                               "00" +   // V Maximum text length for a menu entry
                               "00" +   // V Maximum number of menu entries                              
                               "00" +   // V Maximum number of channels 
                               "00" +   // LV Minimum Security Level field
                               "00" +   // LV TAR Value(s) 
                               "00" );  // V Maximum number of services
          
          
        /*********************************************************************/
        /** Testcase 1. EVENT_UNFORMATTED_SMS_PP_ENV is sent                 */
        /*********************************************************************/      
        // 1- Send envelope Event Unformatted SMS PP ENV (trigger applet1, applet2)
        // Applet1 throws NullPointerException
        response = test.envelopeSmsPp("8B110008 81556677 887FF600 11291200" + 
                                      "000400");
        addResult(response.checkSw("9000"));
                      
        
        /*********************************************************************/
        /** Testcase 2. EVENT_UNFORMATTED_SMS_PP_UPD is sent                 */
        /*********************************************************************/      
        // 1- Send envelope Event Unformatted SMS PP UPD (trigger applet1, applet2)
        // Applet1 throws NullPointerException
        
        //select EF SMS
        test.selectFile("3F00");//Select MF
        test.selectFile("7F10");//Select DF Telecom
        test.selectFile("6F3C");//Select EF SMS
        //update first record
        response = test.updateRecord("01", "04", "03028100 00088155 6677887F F6001129" +
                                     "12000004 10AAAAAA AAAAAAAA AAAAAAAA" +     
                                     "AAAAAAAA AAFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF" +     
                                     "FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF"); 
         addResult(response.checkSw("9000"));
        
        /*********************************************************************/
        /** Testcase 3. EVENT_UNFORMATTED_SMS_CB is sent                     */
        /*********************************************************************/      
       
        // 1- Send envelope Event Formatted SMS CB (trigger applet1, applet2)
        // Applet1 throws NullPointerException
        response = test.envelopeCellBroadcast("0C58C011 1000F611 00000000 00000000" +
                                              "00000000 00000000 00000000 00000000" +
                                              "00000000 00000000 00000000 00000000" +
                                              "00000000 00000000 00000000 00000000" +
                                              "00000000 00000000 00000000 00000000" +
                                              "00000000 00000000 0000");            
        addResult(response.checkSw("9000"));
                                 
        
        
               
        /***********************************/        
        /**         Check results          */        
        /***********************************/         
        
        // Select applet1
        response = test.selectApplication(APPLET_AID_1);
        addResult(response.checkData("10" + APPLET_AID_1 +
                                     "03CCCCCC"));
        // Select applet2
        response = test.selectApplication(APPLET_AID_2);
        addResult(response.checkData("10" + APPLET_AID_2 +
                                     "03CCCCCC"));
    
      
        test.reset();
        test.terminalProfileSession("1719");                                   
        // Delete Applet1 
        test.deleteApplet(APPLET_AID_1);
        // Delete Applet2
        test.deleteApplet(APPLET_AID_2);
        // Delete Package
        test.deletePackage(CAP_FILE_PATH);   
        
        return getOverallResult();
    }
}   
