//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------

package uicc.usim.test.usatframework.ufw_hin_prhd;
//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------


import javacard.framework.*;
import uicc.toolkit.ProactiveResponseHandlerSystem;
import uicc.toolkit.ProactiveResponseHandler;
import uicc.usim.test.util.TestToolkitApplet;


public class Ufw_Hin_Prhd_1 extends TestToolkitApplet {


    /** number of the actual test case */
    private byte    testCaseNb = (byte) 0x01;

    /** flag for test case 1. will be set to true if triggered */
    private boolean bRes       = false;


      /**
     * Method called by the JCRE at the installation of the applet.
     */
    public static void install(byte[] bArray, short bOffset, byte bLength) throws ISOException
    {
        // Create a new applet instance.
        Ufw_Hin_Prhd_1 applet = new Ufw_Hin_Prhd_1();

        // Register the new applet instance to the JCRE
        applet.register(bArray, (short) (bOffset + 1), bArray[bOffset]);

        // Initialise the data of the test applet.
        applet.init();

        short[] eventList = new short[] {
                                        EVENT_FORMATTED_SMS_CB,
                                        EVENT_FORMATTED_SMS_PP_ENV,
                                        EVENT_FORMATTED_SMS_PP_UPD,
                                        EVENT_UNFORMATTED_SMS_CB,
                                        EVENT_UNFORMATTED_SMS_PP_ENV,
                                        EVENT_UNFORMATTED_SMS_PP_UPD,
                                        EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM
                                        };
        //register to all events defined in 3gpp 31.130
        applet.obReg.setEventList(eventList,(short)0,(short)eventList.length);
    }//end install method


    /**
     * Test: ProactiveResponseHandler TLV list shall be empty before the first
     * call to the ProactiveHandler.send() method
     */
    public void processToolkit(short event) throws ISOException
    {
        bRes = false;
        try{
            ProactiveResponseHandler proRhdlr = ProactiveResponseHandlerSystem.getTheHandler();
            //for each event triggering the length of proactive response handler shall be 0x00
            if (proRhdlr.getLength()== (byte)0x00){
                bRes=true;
            }
            //report every triggered event
            reportTestOutcome(testCaseNb,bRes);
            testCaseNb+=(byte)0x01;
        }
        catch(Exception ex){
            reportTestOutcome(testCaseNb,bRes);
            testCaseNb+=(byte)0x01;
        }

    }//end processToolkit method



}//end of class Ufw_Hin_Prhd_1