//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.example.usim_example;

//-----------------------------------------------------------------------------
//	Imports
//-----------------------------------------------------------------------------
import org.etsi.scp.wg3.uicc.jcapi.userclass.*;
import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;
import org._3gpp.ct.wg6.usim.jcapi.userinterface.*;

public class Test_usim_example extends UiccTestModel {

    static final String CAP_FILE_PATH = "uicc/usim/test/example/usim_example";
    static final String CLASS_AID = "A0000000 871005FF FFFFFF89 40000000";
    static final String APPLET_AID = "A0000000 871005FF FFFFFF89 40010001";
    private USimAPITestCardService test;
    APDUResponse response;

    public Test_usim_example() {
        test = USimAPITestCardService.getTheUSimTestCardService();
    }

    public boolean run() {

        boolean result = false;

        // start test
        test.reset();
        test.terminalProfileSession(UiccCardManagementService.DEFAULT_TERMINAL_PROFILE);

        // install package and applet
        test.loadPackage(CAP_FILE_PATH);
        test.installApplet(CAP_FILE_PATH, CLASS_AID, APPLET_AID, "8008" +
                            // TLV UICC Toolkit application specific parameters
                            "01" + // V Priority Level
                            "00" + // V Max. number of timers
                            "0A" + // V Maximum text length for a menu entry
                            "00" + // V Maximum number of menu entries
                            "00" + // V Maximum number of channels 
                            "00" + // LV Minimum Security Level field
                            "00" + // LV TAR Value(s) 
                            "00"); // V Maximum number of services 

        // test script
        test.reset();
        test.terminalProfileSession("03010000 0102");

        // test case 1: trigger applet1
        test.envelopeMoShortMessageControl();

        // check results
        response = test.selectApplication(APPLET_AID);
        result = response.checkData("10A00000 00090002 FFFFFFFF 89445024" 
                                  + "0201CC");

        // delete applet and package
        test.reset();
        test.terminalProfileSession(UiccCardManagementService.DEFAULT_TERMINAL_PROFILE);
        test.deleteApplet(APPLET_AID);
        test.deletePackage(CAP_FILE_PATH);

        return result;
    }
}
